local __exports = LibStub:NewLibrary("ovale/scripts/ovale_paladin_spells", 90106)
if not __exports then return end
__exports.registerPaladinSpells = function(scripts)
    local name = "ovale_paladin_spells"
    local desc = "[9.0] Ovale: Paladin spells"
    local code = [[Define(arcane_torrent 25046)
# Remove s1 beneficial effect from all enemies within A1 yards and restore m2 Energy.
  SpellInfo(arcane_torrent cd=120 gcd=1 energy=-15)
Define(ashen_hallow 316958)
# Hallow the target area for 30 seconds. Enemies in the area suffer up to (55.00000000000001 of Spell Power)*30 seconds/t2 Shadow damage, and allies are healed for up to (42 of Spell Power)*30 seconds/t2, reduced if there are more than s1 targets.rnrnWithin the Hallow, you may use Hammer of Wrath on any target, and its damage is increased by 330382s2.
  SpellInfo(ashen_hallow cd=240 duration=30 tick=2)
Define(avengers_shield 31935)
# Hurls your shield at an enemy target, dealing s1 Holy damage?a231665[, interrupting and silencing the non-Player target for 3 seconds][], and then jumping to x1-1 additional nearby enemies.rnrn|cFFFFFFFFGenerates s4 Holy Power?s337261[, and 337270s1 additional when it damages a target for the first time][].
  SpellInfo(avengers_shield cd=15 duration=3 interrupt=1 holypower=-1)
  # Silenced.
  SpellAddTargetDebuff(avengers_shield avengers_shield add=1)
Define(avenging_crusader 216331)
# You become the ultimate crusader of light, increasing your Crusader Strike, Judgment, and auto-attack damage by s1.rnrnCrusader Strike and Judgment cool down s2 faster and heal up to s6 injured allies for s5 of the damage they deal. Lasts 20 seconds.
  SpellInfo(avenging_crusader cd=120 duration=20 gcd=0 offgcd=1)
  SpellRequire(avenging_crusader unusable set=1 enabled=(not hastalent(avenging_crusader_talent)))
  # Crusader Strike, Judgment and auto-attack damage increased by w1.rnrnCrusader Strike and Judgment cool down w2 faster.rnrnw6 nearby allies will be healed for w5 of the damage done.
  SpellAddBuff(avenging_crusader avenging_crusader add=1)
Define(avenging_wrath 31884)
# Call upon the Light to become an avatar of retribution, increasing your damage, healing, and critical strike chance by s1 for 20 seconds.
  SpellInfo(avenging_wrath cd=180 duration=20 gcd=0 offgcd=1)
  SpellRequire(avenging_wrath replaced_by set=avenging_crusader enabled=(hastalent(avenging_crusader_talent)))
  SpellRequire(avenging_wrath replaced_by set=crusade enabled=(hastalent(crusade_talent)))
  # Damage, healing, and critical strike chance increased by w1.
  SpellAddBuff(avenging_wrath avenging_wrath add=1)
Define(blade_of_justice 184575)
# Pierces an enemy with a blade of light, dealing s1 Physical damage.rnrn|cFFFFFFFFGenerates s2 Holy Power.|r
  SpellInfo(blade_of_justice cd=12 holypower=-1)
Define(blessed_hammer 204019)
# Throws a Blessed Hammer that spirals outward, dealing 204301s1 Holy damage to enemies and reducing the next damage they deal to you by <shield>.rnrn|cFFFFFFFFGenerates s2 Holy Power.
  SpellInfo(blessed_hammer cd=6 duration=5 holypower=-1)
  SpellRequire(blessed_hammer unusable set=1 enabled=(not hastalent(blessed_hammer_talent)))
Define(blessing_of_autumn 328622)
# Bless an ally for 30 seconds, causing their cooldowns to recover s1 faster.rnrn|cFFFFFFFFBlessing of the Seasons:|r Turns to Winter after use.
  SpellInfo(blessing_of_autumn cd=45 duration=30)
  # Cooldowns recover w1 faster.
  SpellAddBuff(blessing_of_autumn blessing_of_autumn add=1)
Define(blessing_of_spring 328282)
# Bless an ally for 30 seconds, increasing their healing done by s1 and healing received by s2.rnrn|cFFFFFFFFBlessing of the Seasons:|r Turns to Summer after use.
  SpellInfo(blessing_of_spring cd=45 duration=30)
  # Healing done increased by w1 and healing received increased by w2.
  SpellAddBuff(blessing_of_spring blessing_of_spring add=1)
Define(blessing_of_summer 328620)
# Bless an ally for 30 seconds, causing their attacks to have a h chance to deal s1 additional damage as Holy.rnrn|cFFFFFFFFBlessing of the Seasons:|r Turns to Autumn after use.
  SpellInfo(blessing_of_summer cd=45 duration=30)
  # Attacks have a h chance to deal w1 additional damage as Holy.
  SpellAddBuff(blessing_of_summer blessing_of_summer add=1)
Define(blessing_of_winter 328281)
# Bless an ally for 30 seconds. Their attacks deal <points> Frost damage and reduce enemies' movement speed by 328506s4 and attack speed by 328506s3, stacking 328506u times.rnrn|cFFFFFFFFBlessing of the Seasons:|r Turns to Spring after use.
  SpellInfo(blessing_of_winter cd=45 duration=30)
  # Attack speed reduced by w3.rnMovement speed reduced by w4.
  SpellAddBuff(blessing_of_winter blessing_of_winter_unused_0 add=1)
  # Attacks deal <points> Frost damage and reduce enemies' movement speed by 328506s4 and attack speed by 328506s3, stacking 328506u times.
  SpellAddBuff(blessing_of_winter blessing_of_winter add=1)
Define(blessing_of_winter_unused_0 328506)
# Bless an ally for 30 seconds. Their attacks deal <points> Frost damage and reduce enemies' movement speed by 328506s4 and attack speed by 328506s3, stacking 328506u times.rnrn|cFFFFFFFFBlessing of the Seasons:|r Turns to Spring after use.
  SpellInfo(blessing_of_winter_unused_0 duration=6 max_stacks=10 gcd=0 offgcd=1)
Define(blinding_light 115750)
# Emits dazzling light in all directions, blinding enemies within 105421A1 yards, causing them to wander disoriented for 105421d. Non-Holy damage will break the disorient effect.
  SpellInfo(blinding_light cd=90 duration=6)
  SpellRequire(blinding_light unusable set=1 enabled=(not hastalent(blinding_light_talent)))
Define(bloodlust 2825)
# Increases haste by (25 of Spell Power) for all party and raid members for 40 seconds.rnrnAllies receiving this effect will become Sated and unable to benefit from Bloodlust or Time Warp again for 600 seconds.
  SpellInfo(bloodlust cd=300 duration=40 gcd=0 offgcd=1)
  # Haste increased by w1.
  SpellAddBuff(bloodlust bloodlust add=1)
Define(consecration 26573)
# Consecrates the land beneath you, causing 81297s1*9 Holy damage over 12 seconds to enemies who enter the area. Limit s2.
  SpellInfo(consecration cd=9 duration=12 tick=1)
  # Damage every t1 sec.
  SpellAddBuff(consecration consecration add=1)
Define(crusade 231895)
# Call upon the Light and begin a crusade, increasing your damage done and haste by <damage> for 25 seconds.rnrnEach Holy Power spent during Crusade increases damage done and haste by an additional <damage>.rnrnMaximum u stacks.
  SpellInfo(crusade cd=120 duration=25 max_stacks=10 gcd=0 offgcd=1)
  SpellRequire(crusade unusable set=1 enabled=(not hastalent(crusade_talent)))
  # ?a206338[Damage done increased by w1.rnHaste increased by w3.][Damage done and haste increased by <damage>.]
  SpellAddBuff(crusade crusade add=1)
Define(crusader_strike 35395)
# Strike the target for s1 Physical damage.rnrn|cFFFFFFFFGenerates s2 Holy Power.
  SpellInfo(crusader_strike cd=6 holypower=-1)
  SpellRequire(crusader_strike replaced_by set=hammer_of_the_righteous enabled=(specialization("protection")))
Define(devotion_aura 465)
# Party and raid members within a1 yards are bolstered by their devotion, reducing damage taken by s1.
  SpellInfo(devotion_aura)
  # Damage taken reduced by w1.
  SpellAddBuff(devotion_aura devotion_aura add=1)
Define(divine_purpose_buff 223819)
# Holy Power abilities have a s1 chance to make your next Holy Power ability free and deal 223819s2 increased damage and healing.
  SpellInfo(divine_purpose_buff duration=12 gcd=0 offgcd=1)
  # Your next Holy Power ability is free and deals s2 increased damage and healing.
  SpellAddBuff(divine_purpose_buff divine_purpose_buff add=1)
Define(divine_storm 53385)
# Unleashes a whirl of divine energy, dealing s1 Holy damage to up to s2 nearby enemies.
  SpellInfo(divine_storm holypower=3)
Define(divine_toll 304971)
# Instantly cast Holy Shock, Avenger's Shield, or Judgment on up to s1 targets within A2 yds (based on your current specialization).
  SpellInfo(divine_toll cd=60)
Define(empyrean_power_buff 326733)
# Crusader Strike has a s1 chance to make your next Divine Storm free and deal 326733s1 additional damage.
  SpellInfo(empyrean_power_buff duration=15 gcd=0 offgcd=1)
Define(execution_sentence 343527)
# A hammer slowly falls from the sky upon the target. After 8 seconds, they suffer s1*<mult> Holy damage, plus s2 of damage taken from your abilities in that time.
  SpellInfo(execution_sentence holypower=3 cd=60 duration=8 tick=8)
  SpellRequire(execution_sentence unusable set=1 enabled=(not hastalent(execution_sentence_talent)))
  # Sentenced to suffer w1 Holy damage.
  SpellAddTargetDebuff(execution_sentence execution_sentence add=1)
Define(final_reckoning 343721)
# Call down a blast of heavenly energy, dealing s2 Holy damage to all targets in the target area and causing them to take s3 increased damage from your Holy Power abilities for 8 seconds.rnrn|cFFFFFFFFPassive:|r While off cooldown, your attacks have a high chance to call down a bolt that deals 343724s1 Holy damage and causes the target to take 343724s2 increased damage from your next Holy Power ability.
  SpellInfo(final_reckoning cd=60 duration=8)
  SpellRequire(final_reckoning unusable set=1 enabled=(not hastalent(final_reckoning_talent)))
  # Taking w3 increased damage from @auracaster's Holy Power abilities.
  SpellAddTargetDebuff(final_reckoning final_reckoning add=1)
Define(fireblood 265221)
# Removes all poison, disease, curse, magic, and bleed effects and increases your ?a162700[Agility]?a162702[Strength]?a162697[Agility]?a162698[Strength]?a162699[Intellect]?a162701[Intellect][primary stat] by 265226s1*3 and an additional 265226s1 for each effect removed. Lasts 8 seconds. ?s195710[This effect shares a 30 sec cooldown with other similar effects.][]
  SpellInfo(fireblood cd=120 gcd=0 offgcd=1)
Define(hammer_of_justice 853)
# Stuns the target for 6 seconds.
  SpellInfo(hammer_of_justice cd=60 duration=6)
  # Stunned.
  SpellAddTargetDebuff(hammer_of_justice hammer_of_justice add=1)
Define(hammer_of_the_righteous 53595)
# Hammers the current target for 53595sw1 Physical damage.?s26573&s203785[rnrnHammer of the Righteous also causes a wave of light that hits all other targets within 88263A1 yds for 88263sw1 Holy damage.]?s26573[rnrnWhile you are standing in your Consecration, Hammer of the Righteous also causes a wave of light that hits all other targets within 88263A1 yds for 88263sw1 Holy damage.][]rnrn|cFFFFFFFFGenerates s2 Holy Power.
  SpellInfo(hammer_of_the_righteous cd=6 holypower=-1)
  SpellRequire(hammer_of_the_righteous replaced_by set=blessed_hammer enabled=(hastalent(blessed_hammer_talent)))
Define(hammer_of_wrath 24275)
# Hurls a divine hammer that strikes an enemy for s1 Holy damage. Only usable on enemies that have less than 20 health?s326730[, or during Avenging Wrath][].rnrn|cFFFFFFFFGenerates s2 Holy Power.
  SpellInfo(hammer_of_wrath cd=7.5 holypower=-1)
Define(holy_avenger 105809)
# Your Holy Power generation is tripled for 20 seconds.
  SpellInfo(holy_avenger cd=180 duration=20 gcd=0 offgcd=1)
  SpellRequire(holy_avenger unusable set=1 enabled=(not hastalent(holy_avenger_talent)))
  # Your Holy Power generation is tripled.
  SpellAddBuff(holy_avenger holy_avenger add=1)
Define(judgment 20271)
# Judges the target, dealing (63.4 of Spell Power) Holy damage?s231663[, and causing them to take 197277s1 increased damage from your next Holy Power ability.][]?s315867[rnrn|cFFFFFFFFGenerates 220637s1 Holy Power.][]
  SpellInfo(judgment cd=12)
  SpellRequire(judgment replaced_by set=judgment_holy enabled=(specialization("holy")))
  SpellRequire(judgment replaced_by set=judgment_protection enabled=(specialization("protection")))
Define(judgment_debuff 197277)
# Judges the target, dealing (63.4 of Spell Power) Holy damage?s231663[, and causing them to take 197277s1 increased damage from your next Holy Power ability.][]?s315867[rnrn|cFFFFFFFFGenerates 220637s1 Holy Power.][]
  SpellInfo(judgment_debuff duration=15 gcd=0 offgcd=1)
  # Taking w1 increased damage from @auracaster's next Holy Power ability.
  SpellAddTargetDebuff(judgment_debuff judgment_debuff add=1)
Define(judgment_holy 275773)
# Judges the target, dealing (112.5 of Spell Power) Holy damage?s231644[, and causing the target to take 214222s2 increased damage from your next Crusader Strike or Holy Shock][].
  SpellInfo(judgment_holy cd=12)
Define(judgment_protection 275779)
# Judges the target, dealing (112.5 of Spell Power) Holy damage?s231663[, and causing them to take 197277s1 increased damage from your next Holy Power ability][].?a315867[rnrn|cFFFFFFFFGenerates 220637s1 Holy Power.][]rn
  SpellInfo(judgment_protection cd=12)
Define(lights_judgment 255647)
# Call down a strike of Holy energy, dealing <damage> Holy damage to enemies within A1 yards after 3 sec.
  SpellInfo(lights_judgment cd=150)
Define(moment_of_glory 327193)
# Reset the cooldown of Avenger's Shield. Your next n Avenger's Shields have no cooldown and deal s2 additional damage.
  SpellInfo(moment_of_glory cd=90 duration=15 gcd=0 offgcd=1)
  SpellRequire(moment_of_glory unusable set=1 enabled=(not hastalent(moment_of_glory_talent)))
  # Your next n Avenger's Shields have no cooldown and deal w2 additional damage.
  SpellAddBuff(moment_of_glory moment_of_glory add=1)
Define(rebuke 96231)
# Interrupts spellcasting and prevents any spell in that school from being cast for 4 seconds.
  SpellInfo(rebuke cd=15 duration=4 gcd=0 offgcd=1 interrupt=1)
Define(seraphim 152262)
# The Light magnifies your power for 15 seconds, granting s1 Haste, Critical Strike, and Versatility, and ?c1[s4*183997bc1]?c2[s4*76671bc1][s4*267316bc1] Mastery.
  SpellInfo(seraphim holypower=3 cd=45 duration=15)
  SpellRequire(seraphim unusable set=1 enabled=(not hastalent(seraphim_talent)))
  # Haste, Critical Strike, and Versatility increased by s1, and Mastery increased by ?c1[s4*183997bc1]?c2[s4*76671bc1][s4*267316bc1].
  SpellAddBuff(seraphim seraphim add=1)
Define(shield_of_the_righteous 53600)
# Slams enemies in front of you with your shield, causing s1 Holy damage, and increasing your Armor by ?c1[132403s1*INT/100][132403s1*STR/100] for 4.5 seconds.
  SpellInfo(shield_of_the_righteous holypower=3 cd=1 gcd=0 offgcd=1)
Define(shield_of_vengeance 184662)
# Creates a barrier of holy light that absorbs <shield> damage for 15 seconds.rnrnWhen the shield expires, it bursts to inflict Holy damage equal to the total amount absorbed, divided among all nearby enemies.
  SpellInfo(shield_of_vengeance cd=120 duration=15)
  # Absorbs w1 damage and deals damage when the barrier fades or is fully consumed.
  SpellAddBuff(shield_of_vengeance shield_of_vengeance add=1)
Define(shining_light_free_buff 327510)
# @spelldesc321136
  SpellInfo(shining_light_free_buff duration=30 gcd=0 offgcd=1)
  # Your next Word of Glory is free.
  SpellAddBuff(shining_light_free_buff shining_light_free_buff add=1)
Define(templars_verdict 85256)
# Unleashes a powerful weapon strike that deals 224266s1 Holy damage to an enemy target.
  SpellInfo(templars_verdict holypower=3)
Define(vanquishers_hammer 328204)
# Throws a hammer at your target dealing (136 of Spell Power) Shadow damage, and empowering your next ?c3[Templar's Verdict to automatically trigger Divine Storm]?c1[Word of Glory to automatically trigger Light of Dawn][Word of Glory to automatically trigger Shield of the Righteous].
  SpellInfo(vanquishers_hammer cd=30 duration=20)
  # Your next ?c3[Templar's Verdict automatically triggers Divine Storm]?c1[Word of Glory automatically triggers Light of Dawn][Word of Glory automatically triggers Shield of the Righteous].
  SpellAddBuff(vanquishers_hammer vanquishers_hammer add=1)
Define(wake_of_ashes 255937)
# Lash out at your enemies, dealing s1 Radiant damage to all enemies within a1 yd in front of you and reducing their movement speed by s2 for 5 seconds. Damage reduced on secondary targets.rnrnDemon and Undead enemies are also stunned for 5 seconds.rnrn|cFFFFFFFFGenerates s3 Holy Power.
  SpellInfo(wake_of_ashes cd=45 duration=5 holypower=-3)
  # Movement speed reduced by s2.
  SpellAddTargetDebuff(wake_of_ashes wake_of_ashes add=1)
Define(war_stomp 20549)
# Stuns up to i enemies within A1 yds for 2 seconds.
  SpellInfo(war_stomp cd=90 duration=2 gcd=0 offgcd=1)
  # Stunned.
  SpellAddTargetDebuff(war_stomp war_stomp add=1)
Define(word_of_glory 85673)
# Calls down the Light to heal a friendly target for 130551s1.?a315921&!a315924[rnrn|cFFFFFFFFProtection:|r If cast on yourself, healing increased by up to 315921s1 based on your missing health.][]?a315924[rnrn|cFFFFFFFFProtection:|r Healing increased by up to 315921s1 based on the target's missing health.][]
  SpellInfo(word_of_glory holypower=3)
SpellList(blessing_of_the_seasons blessing_of_spring blessing_of_summer blessing_of_autumn blessing_of_winter)
Define(avenging_crusader_talent 22190)
# You become the ultimate crusader of light, increasing your Crusader Strike, Judgment, and auto-attack damage by s1.rnrnCrusader Strike and Judgment cool down s2 faster and heal up to s6 injured allies for s5 of the damage they deal. Lasts 20 seconds.
Define(blessed_hammer_talent 23469)
# Throws a Blessed Hammer that spirals outward, dealing 204301s1 Holy damage to enemies and reducing the next damage they deal to you by <shield>.rnrn|cFFFFFFFFGenerates s2 Holy Power.
Define(blinding_light_talent 21811)
# Emits dazzling light in all directions, blinding enemies within 105421A1 yards, causing them to wander disoriented for 105421d. Non-Holy damage will break the disorient effect.
Define(crusade_talent 22215)
# Call upon the Light and begin a crusade, increasing your damage done and haste by <damage> for 25 seconds.rnrnEach Holy Power spent during Crusade increases damage done and haste by an additional <damage>.rnrnMaximum u stacks.
Define(crusaders_judgment_talent 22604)
# Judgment now has 1+s1 charges, and Grand Crusader now also grants a charge of Judgment.
Define(execution_sentence_talent 23467)
# A hammer slowly falls from the sky upon the target. After 8 seconds, they suffer s1*<mult> Holy damage, plus s2 of damage taken from your abilities in that time.
Define(final_reckoning_talent 22634)
# Call down a blast of heavenly energy, dealing s2 Holy damage to all targets in the target area and causing them to take s3 increased damage from your Holy Power abilities for 8 seconds.rnrn|cFFFFFFFFPassive:|r While off cooldown, your attacks have a high chance to call down a bolt that deals 343724s1 Holy damage and causes the target to take 343724s2 increased damage from your next Holy Power ability.
Define(holy_avenger_talent 17599)
# Your Holy Power generation is tripled for 20 seconds.
Define(moment_of_glory_talent 23468)
# Reset the cooldown of Avenger's Shield. Your next n Avenger's Shields have no cooldown and deal s2 additional damage.
Define(sanctified_wrath_talent_protection 23457)
# Avenging Wrath lasts s1 longer and causes Judgment to generate s2 additional Holy Power.
Define(seraphim_talent 17601)
# The Light magnifies your power for 15 seconds, granting s1 Haste, Critical Strike, and Versatility, and ?c1[s4*183997bc1]?c2[s4*76671bc1][s4*267316bc1] Mastery.
Define(potion_of_phantom_fire_item 171349)
    ItemInfo(potion_of_phantom_fire_item cd=300 shared_cd="item_cd_4" rppm=6 proc=307495)
Define(potion_of_spectral_strength_item 171275)
    ItemInfo(potion_of_spectral_strength_item cd=1 shared_cd="item_cd_4" proc=307164)
    ]]
    code = code .. [[
Define(divine_shield 642)
	SpellInfo(divine_shield cd=300 duration=8)
    SpellRequire(divine_shield cd add=-90 enabled=(hastalent(unbreakable_spirit_talent)))
	SpellAddBuff(divine_shield divine_shield add=1)
	SpellRequire(divine_shield unusable set=1 enabled=(debuffpresent(forbearance_debuff)))
Define(forbearance_debuff 25771)
    SpellInfo(forbearance_debuff duration=30)
#hammer_of_wrath
    SpellRequire(hammer_of_wrath unusable set=1 enabled=(target.healthpercent() > 20 and (level()<58 or not buffpresent(avenging_wrath))))
Define(lay_on_hands 633)
    SpellInfo(lay_on_hands cd=600)
    SpellRequire(lay_on_hands cd add=-180 enabled=(hastalent(unbreakable_spirit_talent)))
    SpellRequire(lay_on_hands unusable set=1 enabled=(targetdebuffpresent(forbearance_debuff)))
    SpellAddTargetDebuff(lay_on_hands forbearance_debuff add=1)

    SpellInfo(shield_of_the_righteous holypower=3)
    SpellAddBuff(shield_of_the_righteous shield_of_the_righteous_buff add=1)
    SpellRequire(shield_of_the_righteous holypower set=0 enabled=(buffpresent(divine_purpose_buff)))
    SpellAddBuff(shield_of_the_righteous divine_purpose_buff set=0)
Define(shield_of_the_righteous_buff 132403)
    SpellInfo(shield_of_the_righteous_buff duration=4.5)
Define(unbreakable_spirit_talent 22433)
    SpellRequire(word_of_glory holypower set=0 enabled=(buffpresent(divine_purpose_buff)))
    SpellRequire(word_of_glory holypower set=0 enabled=(buffpresent(shining_light_free_buff)))
    SpellAddBuff(word_of_glory divine_purpose_buff set=0)
    SpellAddBuff(word_of_glory shining_light_free_buff set=0)
    SpellInfo(shining_light_free_buff duration=30)
    ]]
    scripts:registerScript("PALADIN", nil, name, desc, code, "include")
end
